combat = {}

function combat.start(friendly, enemy)
	--[[ determine positioning.
	-- to reverse positioning, subtract from 4.
	-- don't only reverse for drawing -- it'll take two draw functions. Bad.
	-- Thinking about it, draw.friendly and draw.enemy might not be too bad. Compared to an alternate massive clusterfuck.
	-- just do them side by side, have 1 x attack 3 x, 2 x attack 2 x.]]

	---- determine initiative & number of attacks
	initOrder = {}
	combat.initSort(friendly,"A")
	combat.initSort(enemy,"B")
	initOrder = sortByKey(initOrder)
	-- hahaa! I only had to make 2 custom functions.

	---- determine possible targets, decide which to attack.
	for num = 1, #initOrder do
		combat.possibleTargets(friendly, enemy, initOrder[num])
	end

	-- set turn to 1
	turn = 1
	combatTime = 0
	assets.substate = "combat"
end

function combat.iteration()
	--[[ 3 attacks 1 and 2; 2 attacks 1, 2 and 3; 1 attacks 2 and 3

	min
	x = 3 y = 1
	x = 2 y = 1
	x = 1 y = 2

	max
	x = 3 y = 2
	x = 2 y = 3
	x = 1 y = 3


	]]
	local targX
	local temp = love.math.random(math.ceil(2/initOrder[turn].char.x), math.ceil((1.9/initOrder[turn].char.x) + 1.06))
	local invalidTargs = {}

	for num = 1, 2 do
		for num = 1, #initOrder[turn].targs[temp] do
			if initOrder[turn].targs[temp][num].char[9] > 0 then -- if there's at least one valid target, it's fine.
				targX = temp
				break
			elseif num == #initOrder[turn].targs[temp] then
				invalidTargs[#invalidTargs + 1] = temp -- otherwise, there's an invalid target.
			end
		end
		if #initOrder[turn].targs[temp] == 0 then -- if they just straight up don't fucking eixst
			invalidTargs[#invalidTargs + 1] = temp -- then obviously it's invalid.
		end

		if #invalidTargs == 2 then--[[
			1, 2 = 3
			1, 3 = 2
			2, 3 = 1 ]]
			targX = 6 - invalidTargs[1] - invalidTargs[2]
			break
		end

		if initOrder[turn].char.x == 2 then
			if temp == 2 then
				temp = (love.math.random(0,1) * 2) + 1 -- either 1 or 3
			else
				temp = love.math.random(math.ceil(2/temp), math.ceil((1.9/temp) + 1.06)) -- 2 - 3 or 1 - 2
			end
		elseif math.ceil(2/initOrder[turn].char.x) == temp then
			temp = math.ceil((1.9/initOrder[turn].char.x) + 1.06)
		elseif math.ceil((1.9/initOrder[turn].char.x) + 1.06) == temp then
			temp = math.ceil(2/initOrder[turn].char.x)
		end
	end

	local temp = 1
	repeat
		for num = 1, #initOrder[turn].targs[targX] do -- if they're a high priority and not dead
			if initOrder[turn].targs[targX][num].priority == temp and initOrder[turn].targs[targX][num].char[9] > 0 then
				hit = {atk = "ERROR", def = "ERROR", damage = "ERROR"}
				combat.round(initOrder[turn].char, initOrder[turn].targs[targX][num].char)
				temp = 3
				break
			end
		end
		temp = temp + 1
	until temp > 3

	-- check if either side is dead.
	for num = 1, #initOrder do
		if initOrder[num].tag == "A" and initOrder[num].char[9] > 0 then
			break
		elseif num == #initOrder then
			combat.over()
		end
	end
	for num = 1, #initOrder do
		if initOrder[num].tag == "B" and initOrder[num].char[9] > 0 then
			break
		elseif num == #initOrder then
			combat.over()
		end
	end

	repeat
		turn = turn + 1
		if turn > #initOrder then
			combat.over()
			break
		end
	until initOrder[turn].char[9] > 0
end

function combat.possibleTargets(friendly, enemy, initSlot)
	-- init slots holds both their affiliation (A for friendly, B for enemy) and their entire statblock.

	-- decide which squad is going to get hit
	local tarSquad
	if initSlot.tag == "A" then
		tarSquad = enemy -- a is for ally, so they attack the enemy squad.
	elseif initSlot.tag == "B" then
		tarSquad = friendly -- b is for bhostile, so they attack the friendly squad.
	end

	local t = {
		{},{},{}
		}

	local modifier

	if initSlot.char.class.attack[initSlot.char.y] == "melee" then
		modifier = 0 -- if they're a melee unit, they attack the front row.
	else
		modifier = -4 -- otherwise, they attack back to front.
	end

	for num = 1, #tarSquad do
		t[tarSquad[num].x][#t[tarSquad[num].x] + 1] = {char = tarSquad[num], priority = math.abs(modifier + tarSquad[num].y)}
	end

	initSlot.targs = t
end

function combat.initSort(tabl,tag)
	for num = 1 , #tabl do
		for num2 = 1 , tabl[num].class.numAttack[tabl[num].y] do
			-- find the proper number of attacks given their position, this will need to change once I figure out map positioning & flanking
			local correction = 0
			local rand = love.math.random(0,1) -- it multiplies by 10 so it won't fuck up really weirdly if everyone's clustered around a certain number.
			while (initOrder[((num2*500) - tabl[num][5] * 10)  + correction] ~= nil) do
				-- if someone is already at that initiative slot, move them up/down (randomly determined at the start) until they fit.
				if rand == 1 then
					correction = correction + 1
				else
					correction = correction - 1
				end
			end
			initOrder[((num2*500) - tabl[num][5] * 10)  + correction] = {char = tabl[num],tag = tag} -- add them to the initiative at the porper spot
		end
	end
end

function combat.round(attack, defend)
	-- (skill * 2 + luck + weapon hit) - (enemy luck + enemy speed)
	if ((attack[4] * 2) + attack[6] + 50) - (defend[6] + defend[5]) >= (love.math.random(1,100) + love.math.random(1,100)) / 2 then -- it'll take averages, so going up from like, 2 -> 7 is really fucking good,
		local critmod = 1																		-- but there's huge diminishing returns. if your hit chance is 90, you have a
		-- for crit, the chance is skill/2 - enemy luck + weapon crit							-- 98% to hit, if it's 99%, you have a 99.99 % chance to hit. apparent change
		if (attack[4] / 2) - defend[6] >= (love.math.random(1,100) + love.math.random(1,100)) / 2 then		-- of 10 -> realistics change of about 2%.
			critmod = 3
		end

		-- determine the type of attack happening:
		if attack.class.attack[attack.y] == "melee" or attack.class.attack[attack.y] == "ranged" then
			atkType = 2
			defType = 7
		else
			atkType = 3
			defType = 8
		end
		 -- 7 = defense, 2 = attack
		 -- 8 = resist, 3 = magic

		-- now execute the attack
		if (attack[atkType] - defend[defType]) < 1 then -- if it would deal less than 1 damage
			defend[9] = defend[9] - (1 * critmod) -- it deals exactly 1 damage
			hit = {damage = 1, def = defend.name, atk = attack.name}
		else
			defend[9] = defend[9] - ((attack[atkType] - defend[defType]) * critmod) -- otherwise, it does normal damage.
			hit = {damage = attack[atkType] - defend[defType], def = defend.name, atk = attack.name}
		end
	else
		hit = {damage = 0, def = defend.name, atk = attack.name}
	end
end

function combat.over()
	-- so far this just sets the states back.
	assets.substate = "battlemap"
end
