--[[ to do:
	-- long term is on google docs, because holy fuck there's a lot of work to get done.

	-- short term:
	- battle map/grid
	units on the map
	strongholds
	stronghold healing, capture.
	movement radius
	attacking
	turn tracking
	phase tracking
	movement through certain types of terrain
	enemy pathfinding
	terrain bonuses to defense n shit


	- combat
	healing -- this'll be a bitch of an exception.

	- advancement
	techncally, xp would be a part of combat, but I'll put it under this to make the combat stuff less intimidating.
	class change

	- equipment
	everythang lul

	- soldiers. And soldier promotion. Soldier promotion as an EVENT exists, but I need:
	soldier exp for a squad, which I'll link to leader units, to prevent abuse.
	soldier xp will be gained like usual, 2 xp per soldier, 3 soldiers per unit slot.
	soldiers die at 1/3, 2/3 and 3/3 damage, as per usual.
	replenishing soldier numbers, calcualting soldier exp gained, and when healing from any source.



	-- complete:
	- calculating soldiers from unit health
	- classes - basics
	- unit positioning
	- initiative listing is done!
	- target selection
	- attacking
	- battle map
	- grid on map

	]]


function love.run()
	love.math.setRandomSeed(os.time())
	love.event.pump()
	love.load(arg)
    -- We don't want the first frame's dt to include time taken by love.load.
    love.timer.step()
    local dt = 0
    -- Main loop time.
    while true do
		-- Little bit of FPS limit stuff
		local frametimestart = love.timer.getTime()
        -- Process events.
        if love.event then
            love.event.pump()
            for e,a,b,c,d in love.event.poll() do
                if e == "quit" then
                    if not love.quit or not love.quit() then
                        if love.audio then
                            love.audio.stop()
                        end
                        return
                    end
                end
                love.handlers[e](a,b,c,d)
            end
        end
        -- Update dt, as we'll be passing it to update
		love.timer.step()
		dt = love.timer.getDelta()
        -- Call update and draw
        love.update(dt) -- will pass 0 if love.timer is disabled
        if love.window and love.graphics and love.window.isCreated() then
            love.graphics.clear()
            love.graphics.origin()
            if love.draw then love.draw() end
            love.graphics.present()
        end
		-- Uhh, framerate limiting I think (?)
		local framedelta = love.timer.getTime() - frametimestart
		if config.maxfps and config.maxfps > 0 then -- 0 is unlimited
			local max_dt = 1/config.maxfps
			local sleeptime = max_dt - framedelta
			if sleeptime >= 0.001 then -- love will truncate anything less than 1ms down to 0 internally
				love.timer.sleep(sleeptime)
			end
		else
			love.timer.sleep(0.001)
		end
    end
end

function love.load()
	-- misc shit
	config = {maxfps = 60,
		scrollspeed = 400
		}
	love.graphics.setLineStyle("rough")

	assets = {
		stats = {"health",
			"strength",
			"magic",
			"skill",
			"speed",
			"luck",
			"defense",
			"resistance"},
		gamestate = "ingame",
		substate = "battlemap",
		graphics = {
			tileset = love.graphics.newImage("graphics/tileset.png"),
			tiles = {},
			classes = {}
			},
		Xoff = 0,
		Yoff = 0,
		movespeeds = { -- and here is where we store move speds for map tokens.
			[1] = 1,
			[2] = 1.33,
			[3] = 1.33,
			[4] = 2,
			[5] = 2,
			[6] = 2,
			[7] = 2,
			[8] = 4,
			[9] = 6
			},
		-- names is in names.lua
		-- classes are in classes.lua
		}
	require("lua/names")
	require("lua/classes")

	require("lua/combat")

	assets.graphics.classes["Fighter"] = love.graphics.newImage("graphics/classes/fighter.png")
	assets.graphics.classes["Archer"] = love.graphics.newImage("graphics/classes/archer.png")

	local tileX = 32
	local tileY = 32
	local tilesetX = assets.graphics.tileset:getWidth()
	local tilesetY = assets.graphics.tileset:getHeight()
	for y = 1, 4 do
		for x = 1, 4 do
			assets.graphics.tiles[#assets.graphics.tiles + 1] = love.graphics.newQuad((32 * x) - 32, (32 * y) - 32, tileX, tileY, tilesetX, tilesetY)
		end
	end

	army = { -- army -> squads -> units/characters
		player = {
			reserve = {}, -- repository for units without squads.
			soldiers = 20, -- soldiers that are alive, different from unit total.
			-- numbers refer to squad numbers now.
			[1] = {unitGen(175,5,"male"),
				unitGen(175,5,"male"),
				unitGen(175,5,"male"),
				unitGen(175,5,"female"),
				unitGen(175,5,"female")},
			},
		enemy = {
			[1] = {unitGen(175,1,"male"),unitGen(175,1,"male"),unitGen(175,1,"male"),unitGen(175,1,"female"),unitGen(175,1,"female")},
			}
		}

	--[[ unit positions:
	x,y
	1,1;2,1;3,1 |
	1,2;2,2;3,2 V
	1,3;2,2;3,3 Increasing y
	-----> Increasing x
	same as positioning grid for drawables.
	]]



	army.player[1].y = 28
	army.player[1].x = 5

	army.player[1][1].x = 1
	army.player[1][1].y = 1
	army.player[1][1].leader = true

	army.player[1][2].x = 2
	army.player[1][2].y = 1

	army.player[1][3].x = 3
	army.player[1][3].y = 1

	army.player[1][4].x = 1
	army.player[1][4].y = 3

	army.player[1][5].x = 3
	army.player[1][5].y = 3


	army.enemy[1].y = 5
	army.enemy[1].x = 30

	army.enemy[1][1].x = 1
	army.enemy[1][1].y = 1
	army.enemy[1][1].leader = true

	army.enemy[1][2].x = 2
	army.enemy[1][2].y = 1

	army.enemy[1][3].x = 3
	army.enemy[1][3].y = 1

	army.enemy[1][4].x = 1
	army.enemy[1][4].y = 3

	army.enemy[1][5].x = 3
	army.enemy[1][5].y = 3


	require("maps/1")
end

function love.keyreleased(key,unicode)

end

function love.keypressed(key,unicode)
	if key == " " then
		combat.start(army.player[1], army.enemy[1])
	end
end

function love.update(dt)
	collectgarbage("collect", 256)
	if assets.substate == "combat" then
		combatTime = combatTime + dt
		if combatTime > .5 then
			combat.iteration()
			combatTime = 0
		end
	end

	-- map scrolling
	if love.keyboard.isDown("w") then
		assets.Yoff = assets.Yoff - config.scrollspeed * dt
	elseif love.keyboard.isDown("s") then
		assets.Yoff = assets.Yoff + config.scrollspeed * dt
	end

	if love.keyboard.isDown("a") then
		assets.Xoff = assets.Xoff - config.scrollspeed * dt
	elseif love.keyboard.isDown("d") then
		assets.Xoff = assets.Xoff + config.scrollspeed * dt
	end

	if assets.Xoff < 0 then
		assets.Xoff = 0
	elseif assets.Xoff > (#assets.map[1] * 32) - 1280 then
		assets.Xoff = (#assets.map[1] * 32) - 1280
	end

	if assets.Yoff < 0 then
		assets.Yoff = 0
	elseif assets.Yoff > (#assets.map * 32) - 720 then
		assets.Yoff = (#assets.map * 32) - 720
	end

	-- end map scrolling
end

function love.draw()
	love.graphics.setScissor(0,0,1280,720)
	if assets.substate == "battlemap" then
		for y = 1, #assets.map do
			for x = 1, #assets.map[y] do
				love.graphics.draw(assets.graphics.tileset, assets.graphics.tiles[assets.map[y][x]], (x * 32) - 32, (y * 32) - 32, 0, 1, 1, round(assets.Xoff), round(assets.Yoff))
			end
		end

		for num = 1, #army.player do
			for num2 = 1, #army.player[num] do
				if army.player[num][num2].leader == true then
					love.graphics.draw(assets.graphics.classes[army.player[num][num2].class.name], army.player[num].x * 32 - 32, army.player[num].y * 32 - 32, 0, 1, 1, round(assets.Xoff), round(assets.Yoff))
				end
			end
		end
		for num = 1, #army.enemy do
			for num2 = 1, #army.enemy[num] do
				if army.enemy[num][num2].leader == true then
					love.graphics.draw(assets.graphics.classes[army.enemy[num][num2].class.name], army.enemy[num].x * 32 - 32, army.enemy[num].y * 32 - 32, 0, 1, 1, round(assets.Xoff), round(assets.Yoff))
				end
			end
		end

		love.graphics.setColor(0,0,0,63) -- 75% transparency
		for y = 1, #assets.map do
			love.graphics.line(0, round((y * 32) - math.mod(assets.Yoff, 32)) - .5, 1280, round((y * 32) - math.mod(assets.Yoff, 32)) - .5)
		end
		for x = 1, #assets.map[1] do
			love.graphics.line(round((x * 32) - math.mod(assets.Xoff, 32)) - .5, 0, round((x * 32) - math.mod(assets.Xoff, 32)) - .5, 720)
		end
		love.graphics.setColor(255,255,255,255)


	elseif assets.substate == "combat" then
		for num = 1, math.floor(#initOrder/2) do
			love.graphics.print(num..": "..initOrder[num].char.name.." "..initOrder[num].tag,0,15*num + 20)
		end
		for num = math.floor(#initOrder/2) + 1, #initOrder do
			love.graphics.print(num..": "..initOrder[num].char.name.." "..initOrder[num].tag,90,15*num + 20 - (math.floor(#initOrder/2) * 15))
		end
		for num = 1, #initOrder[turn].targs do
			for num2 = 1, #initOrder[turn].targs[num] do
				love.graphics.print(initOrder[turn].targs[num][num2].priority, num * 15,550 + num2 * 15)
			end
		end
		love.graphics.printf(turn,0,0,1280,"right")
		if hit ~= nil then
			love.graphics.print(hit.def.." was hit by "..hit.atk.." for "..hit.damage.." damage!",0,0)
		end
		draw.battle(army.player[1], army.enemy[1])
	end
	love.graphics.setScissor()
end

--------- End Base Functions ---------








---------- Custom functions ----------

--- maps and movement functions ---

-- movement speeds
-- roads - 4 total  					1/move
-- plains - 3 total					1.33/move
-- swamps, forests, etc - 2	total	2/move
-- mountains - 1 total				4/move
-- rivers - 0 moves					5/move
movement = {}

function movement.rangeCalc(squad)
	local t = {}
	local move
	local x
	local y

	-- initial increment, to find possible YX coords to move to
	x, y, move, t = movement.rangeCalcInc(squad.x, squad.y, squad.move, t)

end

-- this would work mostly, but would begin to mess itself up after the second iteration - it would
-- count the movement cost for squares it won't be moving through.
function movement.rangeCalcInc(x, y, move, t)
	move = move - assets.movespeeds[map[y][x]]
	for num = x - 1, x + 1, 2 do
		if move - assets.movespeeds[map[y][num]] > 0 then
			for num2 = 1, #t do
				if t[num] == {y,num} then
					break
				elseif num == #t then
					t[#t + 1] = {y,num}
				end
			end
		end
	end
	for num = y - 1, y + 1, 2 do
		if move - assets.movespeeds[map[num][x]] > 0 then
			for num2 = 1, #t do
				if t[num] == {num,x} then
					break
				elseif num == #t then
					t[#t + 1] = {num,x}
				end
			end
		end
	end

	return x, y, move, t
end



--- unit progression/creation functions ---

function levelup(char)
	local inc = {}
	for num = 1,8 do
		if char.baseGrowth[num] + char.class.growth[num] >= love.math.random(1,100) then
			if char[num] < 40 + char.baseGrowth[num] and num == 1 then
				char[num] = char[num] + 1
				char[9] = char[9] + 1
				inc[#inc + 1] = num
			elseif char[num] < 20 + char.baseGrowth[num] then
				char[num] = char[num] + 1
				inc[#inc + 1] = num
			end
		end
	end
	char.level = char.level + 1
	return inc
end

function unitGen(total, level, gender) -- short for unitGeneration, because I'm lazy and that's twice as many letters as necessary.
	---usually, this'll be called as (190, squad's highest level unit)

	local temp = {0,0,0,0,0,0,0,0}
	repeat

		foo = love.math.random(3,13)
		if foo > total then -- generate for health
			temp[1] = temp[1] + total
			total = 0
			break
		elseif temp[1] + foo >= 40 then
			total = total - (40 - temp[1])
			temp[1] = 40
		else
			temp[1] = temp[1] + foo
			total = total - foo
		end

		-- generate for everything else
		for num = 2, 8 do
			foo = love.math.random(1,10)
			if foo > total then
				temp[num] = temp[num] + total
				total = 0
				break
			elseif temp[num] + foo >= 30 then
				total = total - (30 - temp[num])
				temp[num] = 30
			else
				temp[num] = temp[num] + foo
				total = total - foo
			end
		end
	until total == 0
	table.sort(temp)

	local char = {baseGrowth = {}}

	-- health is always the highest stat
	char.baseGrowth[1] = temp[8]
	table.remove(temp, 8)

	-- randomly distribute all the rest of the stats
	for num = 2,8 do
		num2 = love.math.random(1,#temp)
		char.baseGrowth[num] = temp[num2]
		table.remove(temp, num2)
	end

	-- give them a type and class
	char.type = gender
	if love.math.random(0,1) == 1 then
		char.class = assets.classes.fighter
	else
		char.class = assets.classes.archer
	end

	char[1] = round(level * ((char.class.growth[1] + char.baseGrowth[1]) / 100)) + round(char.baseGrowth[1] / 4) + love.math.random(10, 17) -- health
	if char[1] >= 40 + char.baseGrowth[1] then
		char[1] = 40 + char.baseGrowth[1]
	end
	char[9] = char[1] -- current health = max health
	for num = 2, 8 do
		char[num] = round(level * ((char.class.growth[num] + char.baseGrowth[num]) / 100)) + round(char.baseGrowth[num] / 4) + love.math.random(0, 2)
		if char[num] >= 20 + char.baseGrowth[num] then
			char[num] = 20 + char.baseGrowth[num]
		end
	end
	--1 health
	--2 strength
	--3 magic
	--4 skill
	--5 speed
	--6 luck
	--7 defense
	--8 resistance
	char.level = level -- let's make sure this stays relevant

	char.name = assets.names[char.type][love.math.random(1,#assets.names[char.type])]
	-- pick a random name from the list of possibilities

	return char
end

function calcSoldierNum(unit)
	local temp = round(unit[9] / unit[1]) -- current health out of max health
	if temp > 2/3 then -- if it's over 2/3
		return 3
	elseif temp > 1/3 then -- if it's between 2/3 and 1/3
		return 2
	else -- otherwise it's below 1/3, because if it's below 0, they're dead.
		return 1
	end
end

--- drawing functions ---
draw = {}

-- these are kind of just appendicies I'll use later.
function draw.Char(char)
	local tempx = (char.x * 250) - 250
	local tempy = (char.y * 200) - 200
	love.graphics.print(char.name..", Level "..char.level.." "..char.class.name,tempx,tempy)
	for num = 1, 8 do
		love.graphics.rectangle("line", tempx, (18 * num) + tempy, 82,18)
		love.graphics.print(assets.stats[num], tempx + 3, 2 + (18 * num) + tempy) -- stat names
		love.graphics.rectangle("line", tempx + 82, (18 * num) + tempy, 81,18)
		if (char[num] >= 40 + char.baseGrowth[num] and num == 1) or (char[num] >= 20 + char.baseGrowth[num] and num ~= 1) then
			love.graphics.setColor(0,255,0)
		end
		love.graphics.print(char[num], tempx + 84, 2 + (18 * num) + tempy) -- stat values
		love.graphics.setColor(255,255,255)
		love.graphics.rectangle("line", tempx + 163, (18 * num) + tempy, 81,18)
		love.graphics.print(char.baseGrowth[num].."%", tempx + 166, 2 + (18 * num) + tempy) -- base stat increase percentages
		love.graphics.printf(char.class.growth[num].."%", tempx + 166, 2 + (18 * num) + tempy,77,"right") -- class stat increase percentages
	end
	love.graphics.rectangle("line", tempx, 162 + tempy, 244, 26) -- health box outline
	for num = 1, char[1] do
		if char[9] < num then
			love.graphics.setColor(255,0,0)
		else
			love.graphics.setColor(0,255,0)
		end
		love.graphics.rectangle("fill",  6 * (num - (math.ceil(num/40) * 40)) + tempx + 237, math.ceil(num / 40) * 10 + tempy + 154, 4, 8)
	end
	love.graphics.setColor(255,255,255)
end

function draw.CharSmall(char)
	local tempx = (char.x * 160) + 600
	local tempy = (char.y * 200) - 200
	love.graphics.print(char.name..", Level "..char.level,tempx,tempy)
	for num = 1, 8 do
		love.graphics.rectangle("line", tempx, (18 * num) + tempy, 82,18)
		love.graphics.print(assets.stats[num], tempx + 3, 2 + (18 * num) + tempy) -- stat names
		love.graphics.rectangle("line", tempx + 82, (18 * num) + tempy, 81,18)
		if (char[num] >= 40 + char.baseGrowth[num] and num == 1) or (char[num] >= 20 + char.baseGrowth[num] and num ~= 1) then
			love.graphics.setColor(0,255,0)
		end
		love.graphics.print(char[num], tempx + 84, 2 + (18 * num) + tempy) -- stat values
		love.graphics.setColor(255,255,255)
	end
end

function draw.battle(friendly,enemy)
	love.graphics.setColor(255,255,255)
	draw.combatant(friendly, 0, 0)
	draw.combatant(enemy, 4, 4)
end

function draw.combatant(squad, offsetX, offsetY)
	for num = 1, #squad do
		if squad[num][9] > 0 then
			local tempx = ((math.abs(offsetX - squad[num].x) * 80) + 440)
			local tempy = ((math.abs(offsetY - squad[num].y) * 75) + (4 - offsetX) * 80)
			if hit ~= nil then
				if squad[num].name == hit.atk then
					love.graphics.setColor(0,0,255)
				elseif squad[num].name == hit.def then
					love.graphics.setColor(255,0,0)
				else
					love.graphics.setColor(255,255,255)
				end
			end
			love.graphics.printf(squad[num].name,tempx,tempy, 80, "center")
			love.graphics.printf("HP: "..squad[num][9].."/"..squad[num][1], tempx, tempy + 15, 80, "center") -- health
			love.graphics.printf("hit: "..((squad[num][4] * 2) + squad[num][6] + 50).."\nEv: "..(squad[num][6] + squad[num][5]),tempx, tempy + 30, 80, "center")
			love.graphics.setColor(255,255,255)
		end
	end
end

--- misc functions ---

function sortByKey(tabl)
	-- NOTE!!
	-- This always condenses the table it sorts.
	local t = {}
	for k,v in pairs(tabl) do
		t[#t + 1] = k -- get all the keys into a table
	end
	table.sort(t) -- sort it.
	local y = {} -- make a new temp table.
	for num = 1, #t do -- for each element in the first temp table,
		y[#y + 1] = tabl[t[num]]
	end
	return y
end

function round(num) -- what it says on the tin
	return math.floor(num +.5)
end
